(function( $ ) {
	'use strict';
    $(document).ready(function(){
        var previousAnswer;//for collapse accordion
        var collapseAnswerPrevious;//for collapse accordion

        $(".ays-question-default").on('click',function(){
            $(this).children(".ays-answer").toggle();
            var collapseAnswer = this.nextElementSibling;
            var idCollapse = $(this).parents(".ays-main").data('id');
            if( !$(this).children(".ays-sub-question").hasClass("previous-answer") ) {
                $(this).children(".ays-sub-question").toggleClass("opened-default");
            }

            if(idCollapse === "accordionFAQ"){
                if(previousAnswer != null && !$(this).children(".ays-sub-question").hasClass("previous-answer")){
                    previousAnswer.children(".ays-sub-question").removeClass("opened-default");
                    collapseAnswerPrevious.style.maxHeight = null;
                    $(collapseAnswerPrevious).slideUp(300); //aray
                    previousAnswer.children(".ays-sub-question").removeClass("previous-answer");
                }
                if($(this).children(".ays-sub-question").hasClass("previous-answer")){
                    $(this).children(".ays-sub-question").toggleClass("opened-default");
                }
            }

            if (collapseAnswer.style.maxHeight){
                collapseAnswer.style.maxHeight = null;
                $(collapseAnswer).slideUp(300); //aray
            } else {
                if(idCollapse === "accordionFAQ") {
                    $(this).children(".ays-sub-question").addClass("previous-answer");
                    previousAnswer = $(this);
                    collapseAnswerPrevious = collapseAnswer;
                }
                collapseAnswer.style.maxHeight = "100%";
                $(collapseAnswer).slideDown(300); //aray
            }

            var faqId = $(this).parents('.ays-faq-main').data('id');
            var display_all = $(this).parents('.ays-faq-main').find('#display_all_faq_'+faqId).data('name');

            if(display_all == 'only_first'){
                if (collapseAnswer.style.maxHeight){
                    $(this).parents('#question_block_0').find('.ays-sub-question').addClass("is-collapsed");
                } else {
                    $(this).parents('#question_block_0').find('.ays-sub-question').removeClass("is-collapsed");
                }
                var isCollasped = $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').hasClass('is-collapsed');
                if(isCollasped){
                    $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').removeClass('opened-default');
                    $(this).parents('.ays-main').find('#question_block_0').find(collapseAnswer).slideUp(300);
                }else{
                    $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').addClass('opened-default');
                    $(this).parents('.ays-main').find('#question_block_0').find(collapseAnswer).slideDown(300);
                }
            }else if(display_all == 'yes'){
                if (collapseAnswer.style.maxHeight){
                    $(this).find('.ays-sub-question').addClass("is-collapsed");
                } else {
                    $(this).find('.ays-sub-question').removeClass("is-collapsed");
                }
                var isCollasped = $(this).find('.ays-sub-question').hasClass('is-collapsed');
                if(isCollasped){
                    $(this).find('.ays-sub-question').removeClass('opened-default');
                    $(collapseAnswer).slideUp(300);
                }else{
                    $(this).find('.ays-sub-question').addClass('opened-default');
                    $(collapseAnswer).slideDown(300);
                }
            }
        });
        
        $(".ays-question-plusminus").on('click',function(){
            var titlePlusminusbgc = $(this).parents(".ays-faq-plusminus").children(".ays-title").css("background-color");
            $(this).children(".ays-answer-plusminus").toggle();
            var collapseAnswer = this.nextElementSibling;
            var idCollapse = $(this).parents(".ays-main").data('id');
            if( !$(this).children(".ays-sub-question").hasClass("previous-answer") ) {
                $(this).children(".ays-sub-question").toggleClass("opened-plusminus");
            }

            if(idCollapse === "accordionFAQ"){
                if(previousAnswer != null && !$(this).children(".ays-sub-question").hasClass("previous-answer")){
                    previousAnswer.children(".ays-sub-question").removeClass("opened-plusminus");
                    collapseAnswerPrevious.style.maxHeight = null;
                    $(collapseAnswerPrevious).slideUp(300);
                    previousAnswer.children(".ays-sub-question").removeClass("previous-answer");
                    previousAnswer.removeClass("ays-question-plusminus-opened");
                    previousAnswer.find("label").css("color", "");
                }
                if($(this).children(".ays-sub-question").hasClass("previous-answer")){
                    $(this).children(".ays-sub-question").toggleClass("opened-plusminus");
                }
            }
            if (collapseAnswer.style.maxHeight){
                collapseAnswer.style.maxHeight = null;
                $(collapseAnswer).slideUp(300);
                $(this).removeClass("ays-question-plusminus-opened");//for color
            } else {
                if(idCollapse === "accordionFAQ") {
                    $(this).children(".ays-sub-question").addClass("previous-answer");
                    previousAnswer = $(this);
                    collapseAnswerPrevious = collapseAnswer;
                }
                collapseAnswer.style.maxHeight = "100%";
                $(collapseAnswer).slideDown(300);
                $(this).addClass("ays-question-plusminus-opened");//for color
            }
            if( $(this).hasClass("ays-question-plusminus-opened") ) {
                $(this).find("label").css("color", titlePlusminusbgc);
            } else {
                $(this).find("label").css("color", "");
            }

            var faqId = $(this).parents('.ays-faq-main').data('id');
            var display_all = $(this).parents('.ays-faq-main').find('#display_all_faq_'+faqId).data('name');

            if(display_all == 'only_first'){
                if (collapseAnswer.style.maxHeight){
                    $(this).parents('#question_block_0').find('.ays-sub-question').addClass("is-collapsed");
                } else {
                    $(this).parents('#question_block_0').find('.ays-sub-question').removeClass("is-collapsed");
                }
                var isCollasped = $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').hasClass('is-collapsed');
                if(isCollasped){
                    $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').removeClass('opened-plusminus');
                    $(this).parents('.ays-main').find('#question_block_0').find(collapseAnswer).slideUp(300);
                }else{
                    $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').addClass('opened-plusminus');
                    $(this).parents('.ays-main').find('#question_block_0').find(collapseAnswer).slideDown(300);
                }
            }else if(display_all == 'yes'){
                if (collapseAnswer.style.maxHeight){
                    $(this).find('.ays-sub-question').addClass("is-collapsed");
                } else {
                    $(this).find('.ays-sub-question').removeClass("is-collapsed");
                }
                var isCollasped = $(this).find('.ays-sub-question').hasClass('is-collapsed');
                if(isCollasped){
                    $(this).find('.ays-sub-question').removeClass('opened-plusminus');
                    $(collapseAnswer).slideUp(300);
                }else{
                    $(this).find('.ays-sub-question').addClass('opened-plusminus');
                    $(collapseAnswer).slideDown(300);
                }
            }
        });

        $(".ays-question-simple").on('click',function(){
           var faqId = $(this).parents('.ays-faq-main').data('id');
           var display_all = $(this).parents('.ays-faq-main').find('#display_all_faq_'+faqId).data('name');
            $(this).children(".ays-answer").toggle();
            var collapseAnswer = this.nextElementSibling;
            var idCollapse = $(this).parents(".ays-main").data('id');
            if( !$(this).children(".ays-sub-question").hasClass("previous-answer") ) {
                $(this).children(".ays-sub-question").toggleClass("opened-simple");
            }

            if(idCollapse === "accordionFAQ"){
                if(previousAnswer != null && !$(this).children(".ays-sub-question").hasClass("previous-answer")){
                    previousAnswer.children(".ays-sub-question").removeClass("opened-simple");
                    collapseAnswerPrevious.style.maxHeight = null;
                    $(collapseAnswerPrevious).slideUp(300);
                    previousAnswer.children(".ays-sub-question").removeClass("previous-answer");
                }
                if($(this).children(".ays-sub-question").hasClass("previous-answer")){
                    $(this).children(".ays-sub-question").toggleClass("opened-simple");
                }
            }

            if (collapseAnswer.style.maxHeight){
                collapseAnswer.style.maxHeight = null;
                $(collapseAnswer).slideUp(300);
            } else {
                if(idCollapse === "accordionFAQ") {
                    $(this).children(".ays-sub-question").addClass("previous-answer");
                    previousAnswer = $(this);
                    collapseAnswerPrevious = collapseAnswer;
                }
                collapseAnswer.style.maxHeight = "100%";
                $(collapseAnswer).slideDown(300);
            }
            if(display_all == 'only_first'){
                if (collapseAnswer.style.maxHeight){
                    $(this).parents('#question_block_0').find('.ays-sub-question').addClass("is-collapsed");
                } else {
                    $(this).parents('#question_block_0').find('.ays-sub-question').removeClass("is-collapsed");
                }
                var isCollasped = $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').hasClass('is-collapsed');
                if(isCollasped){
                    $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').removeClass('opened-simple');
                    $(this).parents('.ays-main').find('#question_block_0').find(collapseAnswer).slideUp(300);
                }else{
                    $(this).parents('.ays-main').find('#question_block_0').find('.ays-sub-question').addClass('opened-simple');
                    $(this).parents('.ays-main').find('#question_block_0').find(collapseAnswer).slideDown(300);
                }
            }else if(display_all == 'yes'){
                if (collapseAnswer.style.maxHeight){
                    $(this).find('.ays-sub-question').addClass("is-collapsed");
                } else {
                    $(this).find('.ays-sub-question').removeClass("is-collapsed");
                }
                var isCollasped = $(this).find('.ays-sub-question').hasClass('is-collapsed');
                if(isCollasped){
                    $(this).find('.ays-sub-question').removeClass('opened-simple');
                    $(collapseAnswer).slideUp(300);
                }else{
                    $(this).find('.ays-sub-question').addClass('opened-simple');
                    $(collapseAnswer).slideDown(300);
                }
            }
        });

        //plusminus theme
        let titlePlusminus = $(".ays-faq-plusminus .ays-title");
        let titlebgColor;
        for (let i=0; i<titlePlusminus.length; i++){
            titlebgColor = titlePlusminus.eq(i).css("background-color");
            $(".ays-faq-plusminus").eq(i).css("border-color", titlebgColor);
        }

        //ajax
        $(document).find(".ays-add-question .ays-add-question-submit").on("click", function(){
            let userQuestion = $(this).parent().find(".ays-add-question-input").val();
            let userId = $(this).parents(".ays-faq-main").attr("id").split("_")[1];
            $(this).parents(".ays-add-question").find(".ays-add-question-input").val("");
            if(userQuestion != ""){
                let $this = $(this);
                let userData = {};
                let progressColor =  $this.css("color");
                $this.addClass("on-load");
                $this.css("color", "transparent");
                $this.parent().find(".ays-add-question-input").attr("placeholder", "Adding your question");
                $this.parent().find(".ays-add-question-input").attr("disabled", "disabled");
                $this.attr("disabled", "disabled");
                userData.action = 'ays_get_user_information';
                userData.userQuestion = userQuestion;
                userData.userId = userId;
                $.ajax({
                    url: faq_builder_ays_public.ajax_url,
                    method: 'post',
                    dataType: 'json',
                    data: userData,
                    success: function (response) {
                        if(response !== null){
                            $this.removeAttr("disabled");
                            $this.parent().find(".ays-add-question-input").removeAttr("disabled");
                            $this.parent().find(".ays-add-question-input").attr("placeholder", "");
                            $this.parents(".ays-add-question").find(".ays-add-question-text").show();
                            $this.removeClass("on-load");
                            $this.css("color", progressColor);                
                        }
                    }
                });
            }
            $(document).find(".ays-add-question .ays-add-question-input").on("click", function(){
                $(this).parents(".ays-add-question").find(".ays-add-question-submit").removeAttr("disabled");
                $(this).parents(".ays-add-question").find(".ays-add-question-text").hide();
                $(this).parent().find(".ays-add-question-input").attr("placeholder", "Add your question");
            });
        });

        var disableSimpleThemeBorder = $(document).find("#ays_faq_enable_border_simple_theme").val();
        var faqSimpleThemeDataID = $(document).find("#ays_faq_enable_border_simple_theme").data('id');

        if(disableSimpleThemeBorder){
            $(document).find(' #faq_'+faqSimpleThemeDataID).find('.ays-faq-simple').find('.ays-border-default').removeClass('ays-border-simple');
        }else if(disableSimpleThemeBorder){
            $(document).find(' #faq_'+faqSimpleThemeDataID).find('.ays-faq-simple').find('.ays-border-default').addClass('ays-border-simple');
        }
        
    });
})( jQuery );
